//*****************************************
// AVR ATtiny85 Dekatron(Z562S) Spinner Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:dekatron.c
//
// 	fJgiyTUQrj̐UqA܂͉]
//  PB2 : G1
//  PB3 : G2
//  PB4 : K1_9 L:Active H:No-Active
//
//
//  2016/08/30 New(TAB4)  Taishi
//  2021/02/24 Modify     Taishi Z562S@Ήi_upX fJgj
//  2021/02/25 Modify     Taishi UqɕύX
//  2021/11/28 Modify     Taishi XebvA]AUqAڎ撎̓ɕύX
//*****************************************

#include	<avr/io.h>

#include	"tiny85_z562s_spinner.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"dekatron.h"

// ************************************
//  ړi]j̏ݒ
// ************************************
void	move_init(void)
{
	DDRB  |= ((1 << DDB2) | (1 << DDB3) | (1 << DDB4));		// Port-B Bit2,3,4 : Output
	PORTB &= ~((1 << PB2) | (1 << PB3) | (1 << PB4));		// PB2,3,4 Low
}


#define	ACT_K1_9		PORTB &= ~(1 << PB4)		// K1_9:Active
#define	NOACT_K1_9		PORTB |= (1 << PB4)			// K1_9:No-Active

#define	G1_ON			PORTB |= (1 << PB2)			// G1:ON
#define	G1_OFF			PORTB &= ~(1 << PB2)		// G1:OFF

#define	G2_ON			PORTB |= (1 << PB3)			// G2:ON
#define	G2_OFF			PORTB &= ~(1 << PB3)		// G2:OFF

// ************************************
//  jOɋړ
// ************************************
void	move_k0(void)
{
	NOACT_K1_9;			// K0-set:ON
	delay_ms(100);		// 100mS
	ACT_K1_9;			// K0-set:OFF
}

// ************************************
//  KChAJ\[hړ
//
//   no : jOOԂƂ@J\[hƃKChꏏɂ O`QX̔ԍ
// ************************************
void	n_guid_cathode_move(unsigned char no)
{
	unsigned char	kg12;

	kg12 = (no % 3);									// K,G1,G2̂ǂꂩ߂(0:K, 1:G1, 2:G2)

	if(kg12 == 1){						// G1̎
		G1_ON;							// G1:ON
		delay_2us(10/2);				// 10uS@ԂɂƎ̃J\[hɍs̃J\[hɖ߂鎞
		G2_OFF;							// G2:OFF
	}else if(kg12 == 2){				// G2̎
		G2_ON;							// G2:ON
		delay_2us(10/2);				// 10uS@ԂɂƎ̃J\[hɍs̃J\[hɖ߂鎞
		G1_OFF;							// G1:OFF
	}else{								// K̎
		G1_OFF;							// G1:OFF
		G2_OFF;							// G2:OFF
	}
}

#define	PENDULUM_START	6
#define	PENDULUM_SPAN	16
#define	PENDULUM_WIDTH	3
static	unsigned int	pendulum_syuki[8][16] = {										// iގiPrPʁj
		{200, 200, 100,  80,  60,  50,  40,  30, 30,  40,  50,  60,  80, 100, 200, 200,},
		{140, 140,  70,  56,  42,  35,  28,  20, 20,  28,  35,  42,  56,  70, 140, 140,},
		{100, 100,  50,  40,  30,  25,  20,  15, 15,  20,  25,  30,  40,  50, 100, 100,},
		{ 50,  50,  25,  20,  15,  13,  10,   8,  8,  10,  13,  15,  20,  25,  50,  50,},
		{ 50,  50,  25,  20,  15,  13,  10,   8,  8,  10,  13,  15,  20,  25,  50,  50,},
		{100, 100,  50,  40,  30,  25,  20,  15, 15,  20,  25,  30,  40,  50, 100, 100,},
		{140, 140,  70,  56,  42,  35,  28,  20, 20,  28,  35,  42,  56,  70, 140, 140,},
		{200, 200, 100,  80,  60,  50,  40,  30, 30,  40,  50,  60,  80, 100, 200, 200,},
};

//***************************
// Uq
//***************************
unsigned char	pendulum(void)
{

	unsigned char	uc;
	unsigned char	pin = 0;							// _siJ\[hAKCh܂߂O`TX̔ԍ
	unsigned char	r_pin = 0;							// _ĂsiJ\[hAKCh܂߂O`TX̔ԍ
	unsigned char	move_dir = 0;						// ubN̈ړ@0:CW, 1:CCW
	unsigned char	direction = 0;						// ]@0:CW, 1:CCW
	unsigned char	start = PENDULUM_START;				// _Jnʒu
	unsigned char	end = 0;							// _Iʒu
	unsigned char	syuki_no = 0;


	for(pin = 0;pin < PENDULUM_START;pin++){
		delay_ms(10);									// 10mS Delay
		n_guid_cathode_move(pin);						// KChAJ\[hړ
		r_pin = pin;									// _Ăs
	}

	tim_1ms_inchworm = pendulum_syuki[0][0];			// ubNiގiPrPʁj
	tim_10ms_move_speed = SPEED_CHANGE_TIME;			// 쑬xpPOrPʃ^C}[

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			break;
		}else if(uc == SWR_OFF_LONG){					// 
			break;
		}

		if(tim_1ms_pendulum == 0){
			n_guid_cathode_move(pin);					//  KChAJ\[hړ
			r_pin = pin;								// _Ăs

			if(direction == 0){							// CW
				if(end <= pin){
					direction = 1;
				}else{
					pin++;
				}
			}else{										// CCW
				if(pin <= start){
					direction = 0;
				}else{
					pin--;
				}
			}
			tim_1ms_pendulum = 1;						// iގiPrPʁj
		}

		if(tim_1ms_inchworm == 0){
			tim_1ms_inchworm = pendulum_syuki[syuki_no][start-PENDULUM_START];	// ubNړpiPrPʁj
			if(move_dir == 0){							// ubN̈ړ
				if((PENDULUM_START + PENDULUM_SPAN) <= start){
					move_dir = 1;						// ubN̈ړ CCW
					tim_1ms_inchworm = 1000;			// ubNړpiPrPʁj
				}else{
					start++;
				}
				end = start+PENDULUM_WIDTH;
			}else{
				if(start <= PENDULUM_START){
					move_dir = 0;						// ubN̈ړ CW
					tim_1ms_inchworm = 1000;			// ubNړpiPrPʁj
					if(tim_10ms_move_speed == 0){		// 쑬xp^C}[O̎
						syuki_no++;
						syuki_no &= 0x07;
						tim_10ms_move_speed = SPEED_CHANGE_TIME;	// 쑬xpPOrPʃ^C}[
					}
				}else{
					start--;
				}
				end = start+PENDULUM_WIDTH;
			}
		}

	}

	return(r_pin);										// _Ăs߂
}

//***************************
// ڎ撎
//***************************
unsigned char	inchworm(void)
{

	unsigned char	uc;
	unsigned char	pin = 0;								// _siJ\[hAKCh܂߂O`RX̔ԍ
	unsigned char	r_pin = 0;							// _ĂsiJ\[hAKCh܂߂O`TX̔ԍ
	unsigned char	start = 0;								// _Jnʒu
	unsigned char	end = 0;								// _Iʒu
	unsigned char	direction = 0;							// ]@0:CW, 1:CCW
	unsigned char	tidimu = 0;								// _͈͂kށ@0:Lт, 1:k
	unsigned int	inchworm_time[9] = {500,250,125,63,30,63,125,250,500};	// _͈͂korLт ԁij
	unsigned char	time_no = 0;							// _͈͂korLт Ԃ߂ԍ

	time_no = 0;										// _͈͂korLт Ԃ߂ԍ
	tim_1ms_pendulum = 1;								// iގiPrj
	tim_1ms_inchworm = inchworm_time[time_no];			// ڎ撎piPrPʁj

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			break;
		}else if(uc == SWR_OFF_LONG){					// 
			break;
		}

		if(tim_1ms_pendulum == 0){
			n_guid_cathode_move(pin);					//  KChAJ\[hړ
			r_pin = pin;								// _Ăs

			if(direction == 0){							// CW
				if(end <= pin){
					direction = 1;
				}else{
					pin++;
				}
			}else{										// CCW
				if(pin <= start){
					direction = 0;
				}else{
					pin--;
				}
			}
			tim_1ms_pendulum = 1;						// iގiPrPʁj
		}

		if(tim_1ms_inchworm == 0){
			tim_1ms_inchworm = inchworm_time[time_no];	// ڎ撎piPrPʁj
			if(tidimu == 0){							// Lт鎞
				end++;
				if(end == start+(3*2)){
					tidimu = 1;
					tim_1ms_inchworm = 500;				// ODTb ڎ撎piPrPʁj
				}
			}else{										// kގ
				start++;
				if(end <= start){						// ߂Iɒǂ
					tidimu = 0;
					tim_1ms_inchworm = 500;				// Pb ڎ撎piPrPʁj
					if(30 <= end){						// 
						end = 0;
						start = 0;
						pin= 0;
						time_no++;						// _͈͂korLт Ԃ߂ԍ
						if(9 <= time_no){
							time_no = 0;
						}
					}
				}
			}
		}

	}

	return(r_pin);										// _Ăs߂
}

//***************************
// ]
// 	߂lF̃sԍ@O`QX
//***************************
unsigned char	rotate(void)
{

	unsigned char	uc;
	unsigned char	pin = 0;							// _siJ\[hAKCh܂߂O`TX̔ԍ
	unsigned char	r_pin = 0;							// _ĂsiJ\[hAKCh܂߂O`TX̔ԍ
	unsigned char	direction = 0;						// ]@0:CW, 1:CCW
	unsigned short	syuki[7] = {250, 100, 50, 25, 10, 5, 1,};	// iގiPrPʁj
	unsigned char	syuki_no = 0;

	tim_1ms_pendulum = 0;								// ړ
	tim_10ms_move_speed = SPEED_CHANGE_TIME;			// 쑬xpPOrPʃ^C}[

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			break;
		}else if(uc == SWR_OFF_LONG){					// 
			break;
		}

		if(tim_1ms_pendulum == 0){
			n_guid_cathode_move(pin);					//  KChAJ\[hړ
			r_pin = pin;								// _Ăs
			tim_1ms_pendulum = syuki[syuki_no];			// iގiPrPʁj

			if(direction == 0){							// CW
				if(pin < 29){
					pin++;
				}else{									// 
					pin = 0;
					if(tim_10ms_move_speed == 0){		// 쑬xp^C}[O̎@쑬xύX
						if(6 <= syuki_no){
							direction ^= 1;				// ]ς@0:CW, 1:CCW
						}else{
							syuki_no++;
						}
						tim_10ms_move_speed = SPEED_CHANGE_TIME;	// 쑬xpPOrPʃ^C}[
					}
				}
			}else{										// CCW
				if(0 < pin){
					pin--;
				}else{									// 
					pin = 29;
					if(tim_10ms_move_speed == 0){		// 쑬xp^C}[O̎@쑬xύX
						if(0 < syuki_no){
							syuki_no--;
						}else{
							direction ^= 1;				// ]ς@0:CW, 1:CCW
						}
						tim_10ms_move_speed = SPEED_CHANGE_TIME;	// 쑬xpPOrPʃ^C}[
					}
				}
			}
		}

	}

	return(r_pin);										// _Ăs߂
}

